diff -crN nakedmudv1.5/src/items/#portal.c# nakedmudv2.0/src/items/#portal.c#
*** nakedmudv1.5/src/items/#portal.c#	1969-12-31 18:00:00.000000000 -0600
--- nakedmudv2.0/src/items/#portal.c#	2010-11-01 15:54:18.000000000 -0500
***************
*** 0 ****
--- 1,194 ----
+ //*****************************************************************************
+ //
+ // portal.c
+ //
+ // handles all of the functioning of the portal item type. Stores data about 
+ // the destination vnums of a portal, and does all the legwork for retreiving 
+ // destinations when someone wants to interact with a portal.
+ //
+ //*****************************************************************************
+ 
+ #include "../mud.h"
+ #include "../utils.h"
+ #include "../storage.h"
+ #include "../character.h"
+ #include "../socket.h"
+ #include "../room.h"
+ #include "../world.h"
+ #include "../movement.h"
+ #include "../inform.h"
+ #include "../handler.h"
+ #include "items.h"
+ 
+ #include "../olc2/olc.h"
+ #include "iedit.h"
+ 
+ 
+ //*****************************************************************************
+ // item data for portals
+ //*****************************************************************************
+ typedef struct portal_data {
+   int dest;
+ } PORTAL_DATA;
+ 
+ PORTAL_DATA *newPortalData() {
+   PORTAL_DATA *data = malloc(sizeof(PORTAL_DATA));
+   data->dest = NOWHERE;
+   return data;
+ }
+ 
+ void deletePortalData(PORTAL_DATA *data) {
+   free(data);
+ }
+ 
+ void portalDataCopyTo(PORTAL_DATA *from, PORTAL_DATA *to) {
+   to->dest = from->dest;
+ }
+ 
+ PORTAL_DATA *portalDataCopy(PORTAL_DATA *data) {
+   PORTAL_DATA *new_data = newPortalData();
+   portalDataCopyTo(data, new_data);
+   return new_data;
+ }
+ 
+ STORAGE_SET *portalDataStore(PORTAL_DATA *data) {
+   STORAGE_SET *set = new_storage_set();
+   store_int(set, "dest", data->dest);
+   return set;
+ }
+ 
+ PORTAL_DATA *portalDataRead(STORAGE_SET *set) {
+   PORTAL_DATA *data = newPortalData();
+   data->dest = read_int(set, "dest");
+   return data;
+ }
+ 
+ 
+ 
+ //*****************************************************************************
+ // functions for interacting with portals
+ //*****************************************************************************
+ int portalGetDest(OBJ_DATA *obj) {
+   PORTAL_DATA *data = objGetTypeData(obj, "portal");
+   return data->dest;
+ }
+ 
+ void portalSetDest(OBJ_DATA *obj, int dest) {
+   PORTAL_DATA *data = objGetTypeData(obj, "portal");
+   data->dest = dest;
+ }
+ 
+ 
+ //
+ // cmd_enter is used to go through portals
+ //   usage: enter [object]
+ //
+ //   examples:
+ //     enter portal         enter the thing called "portal" in your room
+ COMMAND(cmd_enter) {
+   if(!arg || !*arg)
+     send_to_char(ch, "What did you want to enter?\r\n");
+   else {
+     int found_type = FOUND_NONE;
+     void *found = generic_find(ch, arg,
+ 			       FIND_TYPE_OBJ | FIND_TYPE_EXIT,
+ 			       FIND_SCOPE_IMMEDIATE,
+ 			       FALSE, &found_type);
+ 
+ 
+     // we're trying to enter an exit
+     if(found && found_type == FOUND_EXIT)
+       try_exit(ch, found, DIR_NONE);
+ 
+     // we're trying to enter a portal
+     else if(found && found_type == FOUND_OBJ) {
+       if(!objIsType(found, "portal"))
+ 	send_to_char(ch, "You cannot seem to find an enterance.\r\n");
+       else {
+ 	ROOM_DATA *dest = worldGetRoom(gameworld, portalGetDest(found));
+ 	if(!dest)
+ 	  send_to_char(ch, 
+ 		       "You go to enter the portal, "
+ 		       "but dark forces prevent you!\r\n");
+ 	else {
+ 	  send_to_char(ch, "You step through %s.\r\n", see_obj_as(ch, found));
+ 	  message(ch, NULL, found, NULL, TRUE, TO_ROOM | TO_NOTCHAR,
+ 		  "$n steps through $o.");
+ 	  char_from_room(ch);
+ 	  char_to_room(ch, dest);
+ 	  look_at_room(ch, dest);
+ 	  message(ch, NULL, found, NULL, TRUE, TO_ROOM | TO_NOTCHAR,
+ 		  "$n arrives after travelling through $o.");
+ 	}
+       }
+     }
+     else
+       send_to_char(ch, "What were you trying to enter?\r\n");
+   }
+ }
+ 
+ 
+ 
+ //*****************************************************************************
+ // portal olc
+ //*****************************************************************************
+ #define IEDIT_PORTAL_DEST      1
+ 
+ // the resedit olc needs these declared
+ void iedit_portal_menu   (SOCKET_DATA *sock, PORTAL_DATA *data) {
+   ROOM_DATA *dest = worldGetRoom(gameworld, data->dest);
+   send_to_socket(sock, "{g1) Destination: {c%d (%s)\r\n", data->dest,
+ 		 (dest ? roomGetName(dest) : "nowhere"));
+ }
+ 
+ int  iedit_portal_chooser(SOCKET_DATA *sock, PORTAL_DATA *data, char option) {
+   switch(toupper(option)) {
+   case '1': 
+     text_to_buffer(sock, "Enter new destination (-1 for none): ");
+     return IEDIT_PORTAL_DEST;
+   default:
+     return MENU_CHOICE_INVALID;
+   }
+ }
+ 
+ bool iedit_portal_parser (SOCKET_DATA *sock, PORTAL_DATA *data, int choice, 
+ 			  const char *arg) {
+   switch(choice) {
+   case IEDIT_PORTAL_DEST: {
+     int dest = atoi(arg);
+     // ugh... ugly logic. Clean this up one day?
+     //   Make sure what we're getting is a positive number or make sure it is
+     //   the NOWHERE number (-1). Also make sure that, if it's not NOWHERE, it
+     //   corresponds to a vnum of a room already created.
+     if((dest != NOWHERE && !worldGetRoom(gameworld, dest)) ||
+        (dest != NOWHERE && !isdigit(*arg)))
+       return FALSE;
+     data->dest = dest;
+     return TRUE;
+   }
+   default:
+     return FALSE;
+   }
+ }
+ 
+ 
+ 
+ //*****************************************************************************
+ // install the portal item type
+ //*****************************************************************************
+ 
+ //
+ // this will need to be called by init_items() in items/items.c
+ void init_portal(void) {
+   item_add_type("portal", 
+ 		newPortalData, deletePortalData,
+ 		portalDataCopyTo, portalDataCopy, 
+ 		portalDataStore, portalDataRead);
+ 
+   // set up the portal OLC too
+   item_add_olc("portal", iedit_portal_menu, iedit_portal_chooser, 
+ 	       iedit_portal_parser);
+ 
+   add_cmd("enter", NULL, cmd_enter, 0, POS_STANDING, POS_FLYING,
+ 	  LEVEL_PLAYER, TRUE, TRUE);
+ }
diff -crN nakedmudv1.5/src/items/portal.c nakedmudv2.0/src/items/portal.c
*** nakedmudv1.5/src/items/portal.c	1969-12-31 18:00:00.000000000 -0600
--- nakedmudv2.0/src/items/portal.c	2010-11-01 15:54:18.000000000 -0500
***************
*** 0 ****
--- 1,194 ----
+ //*****************************************************************************
+ //
+ // portal.c
+ //
+ // handles all of the functioning of the portal item type. Stores data about 
+ // the destination vnums of a portal, and does all the legwork for retreiving 
+ // destinations when someone wants to interact with a portal.
+ //
+ //*****************************************************************************
+ 
+ #include "../mud.h"
+ #include "../utils.h"
+ #include "../storage.h"
+ #include "../character.h"
+ #include "../socket.h"
+ #include "../room.h"
+ #include "../world.h"
+ #include "../movement.h"
+ #include "../inform.h"
+ #include "../handler.h"
+ #include "items.h"
+ 
+ #include "../olc2/olc.h"
+ #include "iedit.h"
+ 
+ 
+ //*****************************************************************************
+ // item data for portals
+ //*****************************************************************************
+ typedef struct portal_data {
+   int dest;
+ } PORTAL_DATA;
+ 
+ PORTAL_DATA *newPortalData() {
+   PORTAL_DATA *data = malloc(sizeof(PORTAL_DATA));
+   data->dest = NOWHERE;
+   return data;
+ }
+ 
+ void deletePortalData(PORTAL_DATA *data) {
+   free(data);
+ }
+ 
+ void portalDataCopyTo(PORTAL_DATA *from, PORTAL_DATA *to) {
+   to->dest = from->dest;
+ }
+ 
+ PORTAL_DATA *portalDataCopy(PORTAL_DATA *data) {
+   PORTAL_DATA *new_data = newPortalData();
+   portalDataCopyTo(data, new_data);
+   return new_data;
+ }
+ 
+ STORAGE_SET *portalDataStore(PORTAL_DATA *data) {
+   STORAGE_SET *set = new_storage_set();
+   store_int(set, "dest", data->dest);
+   return set;
+ }
+ 
+ PORTAL_DATA *portalDataRead(STORAGE_SET *set) {
+   PORTAL_DATA *data = newPortalData();
+   data->dest = read_int(set, "dest");
+   return data;
+ }
+ 
+ 
+ 
+ //*****************************************************************************
+ // functions for interacting with portals
+ //*****************************************************************************
+ int portalGetDest(OBJ_DATA *obj) {
+   PORTAL_DATA *data = objGetTypeData(obj, "portal");
+   return data->dest;
+ }
+ 
+ void portalSetDest(OBJ_DATA *obj, int dest) {
+   PORTAL_DATA *data = objGetTypeData(obj, "portal");
+   data->dest = dest;
+ }
+ 
+ 
+ //
+ // cmd_enter is used to go through portals
+ //   usage: enter [object]
+ //
+ //   examples:
+ //     enter portal         enter the thing called "portal" in your room
+ COMMAND(cmd_enter) {
+   if(!arg || !*arg)
+     send_to_char(ch, "What did you want to enter?\r\n");
+   else {
+     int found_type = FOUND_NONE;
+     void *found = generic_find(ch, arg,
+ 			       FIND_TYPE_OBJ | FIND_TYPE_EXIT,
+ 			       FIND_SCOPE_IMMEDIATE,
+ 			       FALSE, &found_type);
+ 
+ 
+     // we're trying to enter an exit
+     if(found && found_type == FOUND_EXIT)
+       try_exit(ch, found, DIR_NONE);
+ 
+     // we're trying to enter a portal
+     else if(found && found_type == FOUND_OBJ) {
+       if(!objIsType(found, "portal"))
+ 	send_to_char(ch, "You cannot seem to find an enterance.\r\n");
+       else {
+ 	ROOM_DATA *dest = worldGetRoom(gameworld, portalGetDest(found));
+ 	if(!dest)
+ 	  send_to_char(ch, 
+ 		       "You go to enter the portal, "
+ 		       "but dark forces prevent you!\r\n");
+ 	else {
+ 	  send_to_char(ch, "You step through %s.\r\n", see_obj_as(ch, found));
+ 	  message(ch, NULL, found, NULL, TRUE, TO_ROOM | TO_NOTCHAR,
+ 		  "$n steps through $o.");
+ 	  char_from_room(ch);
+ 	  char_to_room(ch, dest);
+ 	  look_at_room(ch, dest);
+ 	  message(ch, NULL, found, NULL, TRUE, TO_ROOM | TO_NOTCHAR,
+ 		  "$n arrives after travelling through $o.");
+ 	}
+       }
+     }
+     else
+       send_to_char(ch, "What were you trying to enter?\r\n");
+   }
+ }
+ 
+ 
+ 
+ //*****************************************************************************
+ // portal olc
+ //*****************************************************************************
+ #define IEDIT_PORTAL_DEST      1
+ 
+ // the resedit olc needs these declared
+ void iedit_portal_menu   (SOCKET_DATA *sock, PORTAL_DATA *data) {
+   ROOM_DATA *dest = worldGetRoom(gameworld, data->dest);
+   send_to_socket(sock, "{g1) Destination: {c%d (%s)\r\n", data->dest,
+ 		 (dest ? roomGetName(dest) : "nowhere"));
+ }
+ 
+ int  iedit_portal_chooser(SOCKET_DATA *sock, PORTAL_DATA *data, char option) {
+   switch(toupper(option)) {
+   case '1': 
+     text_to_buffer(sock, "Enter new destination (-1 for none): ");
+     return IEDIT_PORTAL_DEST;
+   default:
+     return MENU_CHOICE_INVALID;
+   }
+ }
+ 
+ bool iedit_portal_parser (SOCKET_DATA *sock, PORTAL_DATA *data, int choice, 
+ 			  const char *arg) {
+   switch(choice) {
+   case IEDIT_PORTAL_DEST: {
+     int dest = atoi(arg);
+     // ugh... ugly logic. Clean this up one day?
+     //   Make sure what we're getting is a positive number or make sure it is
+     //   the NOWHERE number (-1). Also make sure that, if it's not NOWHERE, it
+     //   corresponds to a vnum of a room already created.
+     if((dest != NOWHERE && !worldGetRoom(gameworld, dest)) ||
+        (dest != NOWHERE && !isdigit(*arg)))
+       return FALSE;
+     data->dest = dest;
+     return TRUE;
+   }
+   default:
+     return FALSE;
+   }
+ }
+ 
+ 
+ 
+ //*****************************************************************************
+ // install the portal item type
+ //*****************************************************************************
+ 
+ //
+ // this will need to be called by init_items() in items/items.c
+ void init_portal(void) {
+   item_add_type("portal", 
+ 		newPortalData, deletePortalData,
+ 		portalDataCopyTo, portalDataCopy, 
+ 		portalDataStore, portalDataRead);
+ 
+   // set up the portal OLC too
+   item_add_olc("portal", iedit_portal_menu, iedit_portal_chooser, 
+ 	       iedit_portal_parser);
+ 
+   add_cmd("enter", NULL, cmd_enter, 0, POS_STANDING, POS_FLYING,
+ 	  LEVEL_PLAYER, TRUE, TRUE);
+ }
diff -crN nakedmudv1.5/src/items/portal.d nakedmudv2.0/src/items/portal.d
*** nakedmudv1.5/src/items/portal.d	1969-12-31 18:00:00.000000000 -0600
--- nakedmudv2.0/src/items/portal.d	2010-11-01 15:54:18.000000000 -0500
***************
*** 0 ****
--- 1,4 ----
+ items/portal.d items/portal.o: items/portal.c mud.h wrapsock.h property_table.h list.h map.h \
+   hashtable.h set.h buffer.h bitvector.h utils.h storage.h character.h \
+   socket.h room.h world.h movement.h inform.h handler.h items/items.h \
+   olc2/olc.h items/iedit.h
diff -crN nakedmudv1.5/src/items/portal.h nakedmudv2.0/src/items/portal.h
*** nakedmudv1.5/src/items/portal.h	1969-12-31 18:00:00.000000000 -0600
--- nakedmudv2.0/src/items/portal.h	2010-11-01 15:54:18.000000000 -0500
***************
*** 0 ****
--- 1,21 ----
+ #ifndef PORTAL_H
+ #define PORTAL_H
+ //*****************************************************************************
+ //
+ // portal.h
+ //
+ // handles all of the functioning of the portal item type. Item keyword type
+ // is "portal". This will be needed for checking if an item is of type portal
+ // with objIsType() from items/items.h
+ //
+ //*****************************************************************************
+ 
+ //
+ // return the vnum of the room that the portal leads to
+ int portalGetDest(OBJ_DATA *obj);
+ 
+ //
+ // set the destination of the portal
+ void portalSetDest(OBJ_DATA *obj, int dest);
+ 
+ #endif // PORTAL_H
diff -crN nakedmudv1.5/src/items/worn.c nakedmudv2.0/src/items/worn.c
*** nakedmudv1.5/src/items/worn.c	1969-12-31 18:00:00.000000000 -0600
--- nakedmudv2.0/src/items/worn.c	2010-11-01 15:54:18.000000000 -0500
***************
*** 0 ****
--- 1,242 ----
+ //*****************************************************************************
+ //
+ // worn.c
+ //
+ // handles all of the functioning of wearable items. Perhaps this could
+ // eventually be extended to include armors? I think, perhaps, one of the 
+ // weirdest things about (most) DIKUs is that worn items and armors are two
+ // different item types; really, wearable items are just armors that provide
+ // no armor class. Fusing the two item types into one might be a much more
+ // fruitful route to take. Or perhaps another route would be to just make 
+ // another item type called "armor" that only functions if the item is also of
+ // type "worn"; it calculates armor class/protection/whatnot based on the type
+ // of worn item the item is.
+ //
+ // that said, I'm not going to do it. Well, not for NakedMud anyways; I don't
+ // want to burden other developers with my conception of what a good way to do
+ // armor class is. Therefore, if you agree with me, I leave the exercise up to
+ // you :)
+ //
+ //*****************************************************************************
+ 
+ #include "../mud.h"
+ #include "../utils.h"
+ #include "../storage.h"
+ #include "../character.h"
+ #include "../socket.h"
+ #include "../room.h"
+ #include "../world.h"
+ #include "../inform.h"
+ #include "../handler.h"
+ 
+ #include "../olc2/olc.h"
+ #include "iedit.h"
+ #include "items.h"
+ #include "worn.h"
+ 
+ 
+ 
+ //*****************************************************************************
+ // local functions, variables, datastructures, and defines
+ //*****************************************************************************
+ 
+ // how big of a table will we need to hold all of the worn data we might have?
+ // optimally, this should be about 120% bigger than the number of worn types
+ // that we have.
+ #define WORN_TABLE_SIZE     50
+ 
+ HASHTABLE *worn_table = NULL;
+ 
+ typedef struct worn_entry {
+   char *type;
+   char *positions;
+ } WORN_ENTRY;  
+ 
+ WORN_ENTRY *newWornEntry(const char *type, const char *positions) {
+   WORN_ENTRY *entry = malloc(sizeof(WORN_ENTRY));
+   entry->type      = strdup(type ? type : "");
+   entry->positions = strdup(positions ? positions : "");
+   return entry;
+ }
+ 
+ void deleteWornEntry(WORN_ENTRY *entry) {
+   if(entry->positions) free(entry->positions);
+   if(entry->type)      free(entry->type);
+   free(entry);
+ }
+ 
+ const char *wornTypeGetPositions(const char *type) {
+   WORN_ENTRY *entry = hashGet(worn_table, type);
+   return (entry ? entry->positions : "");
+ }
+ 
+ 
+ 
+ //*****************************************************************************
+ // item data for worns
+ //*****************************************************************************
+ typedef struct worn_data {
+   char *type;
+ } WORN_DATA;
+ 
+ WORN_DATA *newWornData() {
+   WORN_DATA *data = malloc(sizeof(WORN_DATA));
+   data->type      = strdup("");
+   return data;
+ }
+ 
+ void deleteWornData(WORN_DATA *data) {
+   if(data->type) free(data->type);
+   free(data);
+ }
+ 
+ void wornDataCopyTo(WORN_DATA *from, WORN_DATA *to) {
+   if(to->type) free(to->type);
+   to->type = strdup(from->type ? from->type : "");
+ }
+ 
+ WORN_DATA *wornDataCopy(WORN_DATA *data) {
+   WORN_DATA *new_data = newWornData();
+   wornDataCopyTo(data, new_data);
+   return new_data;
+ }
+ 
+ STORAGE_SET *wornDataStore(WORN_DATA *data) {
+   STORAGE_SET *set = new_storage_set();
+   store_string(set, "type", data->type);
+   return set;
+ }
+ 
+ WORN_DATA *wornDataRead(STORAGE_SET *set) {
+   WORN_DATA *data = newWornData();
+   data->type = strdup(read_string(set, "type"));
+   return data;
+ }
+ 
+ 
+ 
+ //*****************************************************************************
+ // functions for interacting with worns
+ //*****************************************************************************
+ const char *wornGetType(OBJ_DATA *obj) {
+   WORN_DATA *data = objGetTypeData(obj, "worn");
+   return data->type;
+ }
+ 
+ const char *wornGetPositions(OBJ_DATA *obj) {
+   WORN_DATA *data = objGetTypeData(obj, "worn");
+   return wornTypeGetPositions(data->type);
+ }
+ 
+ void wornSetType(OBJ_DATA *obj, const char *type) {
+   WORN_DATA *data = objGetTypeData(obj, "worn");
+   if(data->type) free(data->type);
+   data->type = strdup(type ? type : "");
+ }
+ 
+ 
+ 
+ //*****************************************************************************
+ // worn olc
+ //*****************************************************************************
+ #define IEDIT_WORN_TYPE     1
+ 
+ void iedit_worn_show_types(SOCKET_DATA *sock) {
+   // we want to display them all by alphabetical order
+   LIST *types = newList();
+ 
+   HASH_ITERATOR *hash_i = newHashIterator(worn_table);
+   const char       *key = NULL;
+   WORN_ENTRY       *val = NULL;
+ 
+   // collect all of the types
+   ITERATE_HASH(key, val, hash_i)
+     listPutWith(types, strdup(key), strcasecmp);
+   deleteHashIterator(hash_i);
+ 
+   // display all of the types
+   LIST_ITERATOR *type_i = newListIterator(types);
+   int col = 0;
+ 
+   text_to_buffer(sock, "{wEditable item types:\r\n");
+   ITERATE_LIST(key, type_i) {
+     send_to_socket(sock, "  %-14s%s",
+ 		   key, ((col != 0 && col % 3 == 0) ? "\r\n": "   "));
+     col++;
+   }
+   deleteListIterator(type_i);
+   deleteListWith(types, free);
+   if(col % 3 != 0) text_to_buffer(sock, "\r\n");
+ }
+ 
+ 
+ //
+ // the resedit olc needs these declared
+ void iedit_worn_menu   (SOCKET_DATA *sock, WORN_DATA *data) {
+   send_to_socket(sock, 
+ 		 "{g1) type     : {c%s\r\n"
+ 		 "{g   equips to: {c%s\r\n",
+ 		 data->type, wornTypeGetPositions(data->type));
+ }
+ 
+ int  iedit_worn_chooser(SOCKET_DATA *sock, WORN_DATA *data, char option) {
+   switch(toupper(option)) {
+   case '1':
+     iedit_worn_show_types(sock);
+     text_to_buffer(sock, "enter choice: ");
+     return IEDIT_WORN_TYPE;
+   default:
+     return MENU_CHOICE_INVALID;
+   }
+ }
+ 
+ bool iedit_worn_parser (SOCKET_DATA *sock, WORN_DATA *data, int choice, 
+ 			  const char *arg) {
+   switch(choice) {
+   case IEDIT_WORN_TYPE:
+     if(!hashIn(worn_table, arg))
+       return FALSE;
+     if(data->type) free(data->type);
+     data->type = strdup(arg);
+     return TRUE;
+   default:
+     return FALSE;
+   }
+ }
+ 
+ 
+ 
+ //*****************************************************************************
+ // install the worn item type
+ //*****************************************************************************
+ void worn_add_type(const char *type, const char *required_positions) {
+   WORN_ENTRY *entry = NULL;
+ 
+   // make sure we don't currently have an entry
+   if((entry = hashRemove(worn_table, type)) != NULL)
+     deleteWornEntry(entry);
+   hashPut(worn_table, type, newWornEntry(type, required_positions));
+ }
+ 
+ 
+ //
+ // this will need to be called by init_items() in items/items.c
+ void init_worn(void) {
+   worn_table = newHashtable(WORN_TABLE_SIZE);
+   item_add_type("worn", 
+ 		newWornData, deleteWornData,
+ 		wornDataCopyTo, wornDataCopy, 
+ 		wornDataStore, wornDataRead);
+ 
+   // set up the worn OLC too
+   item_add_olc("worn", iedit_worn_menu, iedit_worn_chooser, iedit_worn_parser);
+ 
+   // add in our basic worn types
+   worn_add_type("shirt",                        "torso");
+   worn_add_type("gloves",       "left hand, right hand");
+   worn_add_type("left glove",               "left hand");
+   worn_add_type("right glove",             "right hand");
+   worn_add_type("earrings",                  "ear, ear");
+   worn_add_type("earring",                        "ear");
+   worn_add_type("ring",                        "finger");
+ }
diff -crN nakedmudv1.5/src/items/worn.d nakedmudv2.0/src/items/worn.d
*** nakedmudv1.5/src/items/worn.d	1969-12-31 18:00:00.000000000 -0600
--- nakedmudv2.0/src/items/worn.d	2010-11-01 15:54:18.000000000 -0500
***************
*** 0 ****
--- 1,4 ----
+ items/worn.d items/worn.o: items/worn.c mud.h wrapsock.h property_table.h list.h map.h \
+   hashtable.h set.h buffer.h bitvector.h utils.h storage.h character.h \
+   socket.h room.h world.h inform.h handler.h olc2/olc.h items/iedit.h \
+   items/items.h items/worn.h
diff -crN nakedmudv1.5/src/items/worn.h nakedmudv2.0/src/items/worn.h
*** nakedmudv1.5/src/items/worn.h	1969-12-31 18:00:00.000000000 -0600
--- nakedmudv2.0/src/items/worn.h	2010-11-01 15:54:18.000000000 -0500
***************
*** 0 ****
--- 1,35 ----
+ #ifndef WORN_H
+ #define WORN_H
+ //*****************************************************************************
+ //
+ // worn.h
+ //
+ // handles all of the functioning of wearable items. Perhaps this could
+ // eventually be extended to include armors? I think, perhaps, one of the 
+ // weirdest things about (most) DIKUs is that worn items and armors are two
+ // different item types; really, wearable items are just armors that provide
+ // no armor class. Fusing the two item types into one might be a much more
+ // fruitful route to take. Or perhaps another route would be to just make 
+ // another item type called "armor" that only functions if the item is also of
+ // type "worn"; it calculates armor class/protection/whatnot based on the type
+ // of worn item the item is.
+ //
+ // that said, I'm not going to do it. Well, not for NakedMud anyways; I don't
+ // want to burden other developers with my conception of what a good way to do
+ // armor class is. Therefore, if you agree with me, I leave the exercise up to
+ // you :)
+ //
+ //*****************************************************************************
+ 
+ //
+ // what type of a worn item is this object? 
+ const char *wornGetType(OBJ_DATA *obj);
+ const char *wornGetPositions(OBJ_DATA *obj);
+ void wornSetType(OBJ_DATA *obj, const char *type);
+ 
+ //
+ // add a new worn type to our list of possible worn types. A type name and
+ // a list of open positions for equipping the item are required.
+ void worn_add_type(const char *type, const char *required_positions);
+ 
+ #endif // WORN_H
